Rep = 1000000;
ns = [30 120 500];
level = .05;
coef = 1;
rng(5014021);

nmodel = 5;
nn = length(ns);

G = 100;
x = 1 + (0:G)'*7/G;
N = length(x);

for vce = 1:3

for modeli = 1:nmodel;

for ni = 1:nn
  n = ns(ni);
  xi = (1:n)'/(n+1);
  if modeli == 1
      X1 = [2;2;2;ones(n-3,1)];
  elseif modeli == 2
      X1 = 1./sqrt(1-xi);
  elseif modeli == 3
      X1 = gaminv(xi,1/4,1);
  elseif modeli == 4
      X1 = exp(norminv(xi));
  elseif modeli == 5
      X1 = exp(norminv(xi)*2);
  end
  sig = X1 + 1;
  X = [X1,ones(n,1)];
  Q = inv(X'*X);
  XQ = X*Q;
  k = size(X,2);
  tstats = zeros(Rep,1);
  for rep = 1:Rep
    Y = randn(n,1).*sig;
    beta = XQ'*Y; 
    e = Y - X*beta;
    h = sum((X.*(X*Q))')';
    if vce == 0
	Xe = XQ.*repmat(e,1,k);
	V = Xe'*Xe;
    elseif vce == 1
	Xe = XQ.*repmat(e,1,k);
	V = (Xe'*Xe)*(n/(n-k));
    elseif vce == 2
	if max(h) < 1
  	   Xe = XQ.*repmat(e./sqrt(1-h),1,k);
	   V = Xe'*Xe;
	else
	   Xe = XQ.*repmat(e,1,k);
	   V = (Xe'*Xe)*(n/(n-k));
	end
    elseif vce == 3
	if max(h) < 1
  	   Xe = XQ.*repmat(e./(1-h),1,k);
	   V = Xe'*Xe;
	else
	   Xe = XQ.*repmat(e,1,k);
	   V = (Xe'*Xe)*(n/(n-k));
	end
    end
    tstats(rep) = beta(coef)./sqrt(V(coef,coef));
  end
  f3 = zeros(G+1,1);
  for i = 1:(G+1)
    f3(i) = mean(tstats <= x(i));
  end
  f1 = T3cdf(x,X,sig,vce,coef);
  f2 = T4cdf(x,X,sig,vce,coef);
  plot(x,f1,'-.',x,f2,'--',x,f3,'Linewidth',.7);
  ylim([.8 1]);
  legend('Three-Parameter Distribution','Four-Parameter Distribution','Exact Distribution','Location','southeast');
  set(gcf, 'PaperPosition', [0 0 5 5]);
  set(gcf, 'PaperSize', [5 5]);
  name1 = ['DiffHeteroHC' num2str(vce) 'Model' num2str(modeli) 'n' num2str(n) '.pdf'];
  saveas(gcf,name1);
end
end
end