function G = T3cdf(x,X,sig,vce,coef)

tolerance = .0001;
n = size(X,1);
k = size(X,2);
nx = length(x);
Q = inv(X'*X);
XQ = X*Q;
Z = XQ(:,coef);
B0 = Z.^2;
if vce == 0
	B = B0;
else
	B = B0*(n/(n-k));
end
if vce > 1
	h = sum((X.*XQ)')';
	if (max(h) < 1)*(vce == 2)
		B = B0./(1-h);
	elseif (max(h) < 1)*(vce == 3)
		B = B0./((1-h).^2);
	end
end
XQsig = XQ.*sig;
XQsigR = XQsig(:,coef);
A1 = XQsigR*(XQsigR');
Msig = diag(sig) - XQsig*(X');
A2 = (Msig.*(B'))*(Msig');

G = zeros(nx,1);
for i = 1:nx
   xi = x(i);
   if abs(xi) > eps
	C = A1 - A2*(xi^2);
	[H1,lambda1] = eigs(C,1,'largestreal');
	C1 = H1*(lambda1*H1') - C;
	C2 = C1'*C1;
	mu1 = sum(diag(C1));
	mu2 = sum(diag(C2));
	mu3 = sum(sum(C2.*C1));
	a = (mu1 - (mu2^2)/mu3)/lambda1;
	b = (mu3/mu2)/lambda1;
	r = (mu2^3)/(mu3^2);
	if r > eps
		Gi = integral(@(x) fun(x,a,b,r),0,Inf,'RelTol',0,'AbsTol',tolerance);
		G(i) = Gi*(xi > 0) + (1 - Gi)*(xi <  0);
	else
	 	G(i) = 0.5;
	end
   else
 	G(i) = 0.5;
   end
end

function G = fun(x,a,b,r)
	G = normcdf(sqrt(a+x*b)).*chi2pdf(x,r);
end

end