ns = [30 60 120 250 500 1000 2000];
level = .05;
coef = 1;
vce = 1;
x = 3;

nmodel = 5;
delete Table5.txt;

nn = length(ns);
timeT3 = zeros(nmodel,nn);
timeT4 = zeros(nmodel,nn);
M4 = zeros(nmodel,nn);

for het = 0:1
for modeli = 1:nmodel;
for ni = 1:nn
  n = ns(ni);
  xi = (1:n)'/(n+1);
  if modeli == 1
      X1 = [2;2;2;ones(n-3,1)];
  elseif modeli == 2
      X1 = 1./sqrt(1-xi);
  elseif modeli == 3
      X1 = gaminv(xi,1/4,1);
  elseif modeli == 4
      X1 = exp(norminv(xi));
  elseif modeli == 5
      X1 = exp(norminv(xi)*2);
  end
  if het == 0;
	sig = ones(n,1);
  else
	  sig = X1;
  end
  X = [X1,ones(n,1)];
  f3 = @() T3cdf(x,X,sig,vce,coef);
  f4 = @() T4cdf(x,X,sig,vce,coef);
  timeT3(modeli,ni) = timeit(f3);
  timeT4(modeli,ni) = timeit(f4);
  [G,M] = T4cdfM(x,X,sig,vce,coef);
  M4(modeli,ni) = M;
end
end

diary Table5.txt;
disp('---------------------')
fprintf('Time to Compute CDF\r\n');
fprintf('x values\r\n');
disp(x');
if het==0;
  fprintf('Homoskedastic Case\r\n');
else
  fprintf('Heteroskedastic Case\r\n');
end
disp(ns);
fprintf('T3cdf\r\n');
disp(timeT3)
disp('---------------------')
fprintf('T4cdf\r\n');
disp(timeT4)
disp('---------------------')
fprintf('M\r\n');
disp(M4)
disp('---------------------')
diary off;

end
